diff --git a/libavformat/dvenc.c b/libavformat/dvenc.c
index b04d6044d7..915ac9527d 100644
--- a/libavformat/dvenc.c
+++ b/libavformat/dvenc.c
@@ -97,7 +97,6 @@ static int dv_write_pack(enum dv_pack_type pack_id, DVMuxContext *c, uint8_t* bu
     switch (pack_id) {
     case dv_timecode:
         timecode  = av_timecode_get_smpte_from_framenum(&c->tc, c->frames);
-        timecode |= 1<<23 | 1<<15 | 1<<7 | 1<<6; // biphase and binary group flags
         AV_WB32(buf + 1, timecode);
         break;
     case dv_audio_source:  /* AAUX source pack */
diff --git a/tests/ref/lavf/dv b/tests/ref/lavf/dv
index 7ae4223a21..6f7ea319e7 100644
--- a/tests/ref/lavf/dv
+++ b/tests/ref/lavf/dv
@@ -1,3 +1,3 @@
-2fb332aab8f2ba9c33b1b2368194392a *tests/data/lavf/lavf.dv
+c79671431b71e00b6d70d50a1cb560a9 *tests/data/lavf/lavf.dv
 3600000 tests/data/lavf/lavf.dv
 tests/data/lavf/lavf.dv CRC=0xbdaf7f52
diff --git a/tests/ref/lavf/dv_ntsc b/tests/ref/lavf/dv_ntsc
index 410b6ec254..f4663d3e32 100644
--- a/tests/ref/lavf/dv_ntsc
+++ b/tests/ref/lavf/dv_ntsc
@@ -1,3 +1,3 @@
-5569626370c7c72d40de2c4559e32856 *tests/data/lavf/lavf.dv_ntsc
+af21369e617965e4625d34fc60af7787 *tests/data/lavf/lavf.dv_ntsc
 3480000 tests/data/lavf/lavf.dv_ntsc
 tests/data/lavf/lavf.dv_ntsc CRC=0xa0088163
diff --git a/tests/ref/lavf/dv_pal b/tests/ref/lavf/dv_pal
index 93bb728c46..5d7818f76f 100644
--- a/tests/ref/lavf/dv_pal
+++ b/tests/ref/lavf/dv_pal
@@ -1,3 +1,3 @@
-7830f9c6716ceb6011f865f1e521b951 *tests/data/lavf/lavf.dv_pal
+bbcfa20cb185e13352178457d9755848 *tests/data/lavf/lavf.dv_pal
 3600000 tests/data/lavf/lavf.dv_pal
 tests/data/lavf/lavf.dv_pal CRC=0xd428d3ee
diff --git a/tests/ref/vsynth/vsynth1-dv b/tests/ref/vsynth/vsynth1-dv
index ea357b7723..2964b1bc29 100644
--- a/tests/ref/vsynth/vsynth1-dv
+++ b/tests/ref/vsynth/vsynth1-dv
@@ -1,4 +1,4 @@
-4246668d61439617101d051d7a995108 *tests/data/fate/vsynth1-dv.dv
+c78d747be2c1151d7dc5680a86ca23c3 *tests/data/fate/vsynth1-dv.dv
 7200000 tests/data/fate/vsynth1-dv.dv
 d52e7a9eac459ade9561d0b89bba58e7 *tests/data/fate/vsynth1-dv.out.rawvideo
 stddev:    6.90 PSNR: 31.34 MAXDIFF:   76 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth1-dv-411 b/tests/ref/vsynth/vsynth1-dv-411
index ec88d67ece..0b08a6a9ac 100644
--- a/tests/ref/vsynth/vsynth1-dv-411
+++ b/tests/ref/vsynth/vsynth1-dv-411
@@ -1,4 +1,4 @@
-df067afe65f1712d9e8efa7117aab6ea *tests/data/fate/vsynth1-dv-411.dv
+4c1017a99b78ff015415283906fb3a80 *tests/data/fate/vsynth1-dv-411.dv
 7200000 tests/data/fate/vsynth1-dv-411.dv
 ed493bad827dc903188fce8d3b597fcb *tests/data/fate/vsynth1-dv-411.out.rawvideo
 stddev:    9.45 PSNR: 28.62 MAXDIFF:   84 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth1-dv-50 b/tests/ref/vsynth/vsynth1-dv-50
index 4a2ff00110..54d0a531c1 100644
--- a/tests/ref/vsynth/vsynth1-dv-50
+++ b/tests/ref/vsynth/vsynth1-dv-50
@@ -1,4 +1,4 @@
-adb1df1a65cecab225677003a5de9f28 *tests/data/fate/vsynth1-dv-50.dv
+eddfa29c6fcee5574256eb9878112214 *tests/data/fate/vsynth1-dv-50.dv
 14400000 tests/data/fate/vsynth1-dv-50.dv
 4ab1f5b7aad15fab9e3c1ea5b96da39b *tests/data/fate/vsynth1-dv-50.out.rawvideo
 stddev:    1.72 PSNR: 43.37 MAXDIFF:   29 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth1-dv-fhd b/tests/ref/vsynth/vsynth1-dv-fhd
index b81141f340..257898e0b2 100644
--- a/tests/ref/vsynth/vsynth1-dv-fhd
+++ b/tests/ref/vsynth/vsynth1-dv-fhd
@@ -1,4 +1,4 @@
-74315a8678d12c7f592c02990dc8952d *tests/data/fate/vsynth1-dv-fhd.dv
+d16b498c00ffaf3ed0b750e0a597bbe7 *tests/data/fate/vsynth1-dv-fhd.dv
 28800000 tests/data/fate/vsynth1-dv-fhd.dv
 c95b309bc128b162e5c8241374eb66a9 *tests/data/fate/vsynth1-dv-fhd.out.rawvideo
 stddev:    2.53 PSNR: 40.03 MAXDIFF:   35 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth1-dv-hd b/tests/ref/vsynth/vsynth1-dv-hd
index 6b6d6e8159..e22f28c704 100644
--- a/tests/ref/vsynth/vsynth1-dv-hd
+++ b/tests/ref/vsynth/vsynth1-dv-hd
@@ -1,4 +1,4 @@
-22d1d62a834fe8416fe79c51760012c1 *tests/data/fate/vsynth1-dv-hd.dv
+77f146c73a24495495c649f1e0d26fee *tests/data/fate/vsynth1-dv-hd.dv
 14400000 tests/data/fate/vsynth1-dv-hd.dv
 34b78cf725346c7f819c9d6209b8299a *tests/data/fate/vsynth1-dv-hd.out.rawvideo
 stddev:    4.30 PSNR: 35.45 MAXDIFF:   74 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth2-dv b/tests/ref/vsynth/vsynth2-dv
index 3127b56288..95a76c5de2 100644
--- a/tests/ref/vsynth/vsynth2-dv
+++ b/tests/ref/vsynth/vsynth2-dv
@@ -1,4 +1,4 @@
-6a059698f1f619312dd91504697cca98 *tests/data/fate/vsynth2-dv.dv
+74f8d319aaad9b1e9e56dda80023013b *tests/data/fate/vsynth2-dv.dv
 7200000 tests/data/fate/vsynth2-dv.dv
 528fd407b6d19f5fe3b3446a3080d148 *tests/data/fate/vsynth2-dv.out.rawvideo
 stddev:    1.99 PSNR: 42.13 MAXDIFF:   38 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth2-dv-411 b/tests/ref/vsynth/vsynth2-dv-411
index 3cee4de303..7246c1ac61 100644
--- a/tests/ref/vsynth/vsynth2-dv-411
+++ b/tests/ref/vsynth/vsynth2-dv-411
@@ -1,4 +1,4 @@
-a4afd3c595b4242fb5f1329c82a0b0c2 *tests/data/fate/vsynth2-dv-411.dv
+0fa84f9a9a6f6be9b5bb1a21282693ec *tests/data/fate/vsynth2-dv-411.dv
 7200000 tests/data/fate/vsynth2-dv-411.dv
 1ef9bd89b72a942c02571f32af03bb04 *tests/data/fate/vsynth2-dv-411.out.rawvideo
 stddev:    3.48 PSNR: 37.29 MAXDIFF:   56 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth2-dv-50 b/tests/ref/vsynth/vsynth2-dv-50
index 707fd5c734..7cf15bfce9 100644
--- a/tests/ref/vsynth/vsynth2-dv-50
+++ b/tests/ref/vsynth/vsynth2-dv-50
@@ -1,4 +1,4 @@
-8774632954e780697c472d945c597daf *tests/data/fate/vsynth2-dv-50.dv
+c3d213eb5cf87ec550aa34036de6ded4 *tests/data/fate/vsynth2-dv-50.dv
 14400000 tests/data/fate/vsynth2-dv-50.dv
 11167de05c205f974d462f91f56eb837 *tests/data/fate/vsynth2-dv-50.out.rawvideo
 stddev:    0.86 PSNR: 49.43 MAXDIFF:   17 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth2-dv-fhd b/tests/ref/vsynth/vsynth2-dv-fhd
index 948bf2269f..e93de1238b 100644
--- a/tests/ref/vsynth/vsynth2-dv-fhd
+++ b/tests/ref/vsynth/vsynth2-dv-fhd
@@ -1,4 +1,4 @@
-1f96ce7c1a5f09ec9d30c51c7271cf77 *tests/data/fate/vsynth2-dv-fhd.dv
+3649c5719995bc5a2573942c4532ec7d *tests/data/fate/vsynth2-dv-fhd.dv
 28800000 tests/data/fate/vsynth2-dv-fhd.dv
 cff30e2430730522bf67c6d94cf1352e *tests/data/fate/vsynth2-dv-fhd.out.rawvideo
 stddev:    1.16 PSNR: 46.82 MAXDIFF:   21 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth2-dv-hd b/tests/ref/vsynth/vsynth2-dv-hd
index c6dcb5a953..5c4ed86fe7 100644
--- a/tests/ref/vsynth/vsynth2-dv-hd
+++ b/tests/ref/vsynth/vsynth2-dv-hd
@@ -1,4 +1,4 @@
-4270e5d552e0a05193f44bff75c2d271 *tests/data/fate/vsynth2-dv-hd.dv
+168f80951daf5eeefacac33fd06db87d *tests/data/fate/vsynth2-dv-hd.dv
 14400000 tests/data/fate/vsynth2-dv-hd.dv
 15dbe911532aca81c67bdd2846419027 *tests/data/fate/vsynth2-dv-hd.out.rawvideo
 stddev:    1.75 PSNR: 43.26 MAXDIFF:   34 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth3-dv-fhd b/tests/ref/vsynth/vsynth3-dv-fhd
index 08ca9ef889..c181fb5beb 100644
--- a/tests/ref/vsynth/vsynth3-dv-fhd
+++ b/tests/ref/vsynth/vsynth3-dv-fhd
@@ -1,4 +1,4 @@
-5b8b7f1dc31d7076af891e94c2e88c06 *tests/data/fate/vsynth3-dv-fhd.dv
+d1b2b0be1a0ab43eca24a881cc809cfd *tests/data/fate/vsynth3-dv-fhd.dv
 28800000 tests/data/fate/vsynth3-dv-fhd.dv
 a038ad7c3c09f776304ef7accdea9c74 *tests/data/fate/vsynth3-dv-fhd.out.rawvideo
 stddev:    0.00 PSNR:999.99 MAXDIFF:    0 bytes:    86700/    86700
diff --git a/tests/ref/vsynth/vsynth3-dv-hd b/tests/ref/vsynth/vsynth3-dv-hd
index d069e6980e..ed94d08155 100644
--- a/tests/ref/vsynth/vsynth3-dv-hd
+++ b/tests/ref/vsynth/vsynth3-dv-hd
@@ -1,4 +1,4 @@
-2f81f3ccec178ba2fd9d3e3b46f33670 *tests/data/fate/vsynth3-dv-hd.dv
+1211b843d8dde81c583023e15beff35a *tests/data/fate/vsynth3-dv-hd.dv
 14400000 tests/data/fate/vsynth3-dv-hd.dv
 a038ad7c3c09f776304ef7accdea9c74 *tests/data/fate/vsynth3-dv-hd.out.rawvideo
 stddev:    0.00 PSNR:999.99 MAXDIFF:    0 bytes:    86700/    86700
diff --git a/tests/ref/vsynth/vsynth_lena-dv b/tests/ref/vsynth/vsynth_lena-dv
index a8041f36a5..9d8af7ead6 100644
--- a/tests/ref/vsynth/vsynth_lena-dv
+++ b/tests/ref/vsynth/vsynth_lena-dv
@@ -1,4 +1,4 @@
-ab03241e988dcd5bd36a76b25372343f *tests/data/fate/vsynth_lena-dv.dv
+ac31f6d9633b0de16c531ac22c97324f *tests/data/fate/vsynth_lena-dv.dv
 7200000 tests/data/fate/vsynth_lena-dv.dv
 6e4b90be39ad408ddc1c0dc4ced40bf0 *tests/data/fate/vsynth_lena-dv.out.rawvideo
 stddev:    1.69 PSNR: 43.54 MAXDIFF:   33 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth_lena-dv-411 b/tests/ref/vsynth/vsynth_lena-dv-411
index 164dd359b2..e78448f779 100644
--- a/tests/ref/vsynth/vsynth_lena-dv-411
+++ b/tests/ref/vsynth/vsynth_lena-dv-411
@@ -1,4 +1,4 @@
-1a7f091993eb6fe5b6f9d927ba60387d *tests/data/fate/vsynth_lena-dv-411.dv
+e4c73e811537e15500f37b54c34b5deb *tests/data/fate/vsynth_lena-dv-411.dv
 7200000 tests/data/fate/vsynth_lena-dv-411.dv
 e5624f3d4de96e514ac9b96c2b4b447c *tests/data/fate/vsynth_lena-dv-411.out.rawvideo
 stddev:    2.87 PSNR: 38.97 MAXDIFF:   45 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth_lena-dv-50 b/tests/ref/vsynth/vsynth_lena-dv-50
index 2149fd553c..95f9edc0f8 100644
--- a/tests/ref/vsynth/vsynth_lena-dv-50
+++ b/tests/ref/vsynth/vsynth_lena-dv-50
@@ -1,4 +1,4 @@
-c678b291e58a277725aa4557387efc58 *tests/data/fate/vsynth_lena-dv-50.dv
+efc2a3ec905b74628d3fa996336d15bc *tests/data/fate/vsynth_lena-dv-50.dv
 14400000 tests/data/fate/vsynth_lena-dv-50.dv
 bda4f98f387f82986e521b78a9bc1eef *tests/data/fate/vsynth_lena-dv-50.out.rawvideo
 stddev:    0.78 PSNR: 50.28 MAXDIFF:   12 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth_lena-dv-fhd b/tests/ref/vsynth/vsynth_lena-dv-fhd
index 51a4505011..1d3b652837 100644
--- a/tests/ref/vsynth/vsynth_lena-dv-fhd
+++ b/tests/ref/vsynth/vsynth_lena-dv-fhd
@@ -1,4 +1,4 @@
-3a33e512f8b3f4213477c98d4e7e2559 *tests/data/fate/vsynth_lena-dv-fhd.dv
+43ed25885d6a290b5cb391b62e0565de *tests/data/fate/vsynth_lena-dv-fhd.dv
 28800000 tests/data/fate/vsynth_lena-dv-fhd.dv
 b97e0a057202359ef93f2ec0b9fdfec4 *tests/data/fate/vsynth_lena-dv-fhd.out.rawvideo
 stddev:    1.03 PSNR: 47.80 MAXDIFF:   14 bytes:  7603200/  7603200
diff --git a/tests/ref/vsynth/vsynth_lena-dv-hd b/tests/ref/vsynth/vsynth_lena-dv-hd
index aba756c5f1..6764f03c35 100644
--- a/tests/ref/vsynth/vsynth_lena-dv-hd
+++ b/tests/ref/vsynth/vsynth_lena-dv-hd
@@ -1,4 +1,4 @@
-01a61c53943a421fa6a5e03dbc205972 *tests/data/fate/vsynth_lena-dv-hd.dv
+fa8df53531f9e58f90bc9a33e5c78ca8 *tests/data/fate/vsynth_lena-dv-hd.dv
 14400000 tests/data/fate/vsynth_lena-dv-hd.dv
 4db4175c80ea1f16b7ec303611b8873a *tests/data/fate/vsynth_lena-dv-hd.out.rawvideo
 stddev:    1.49 PSNR: 44.66 MAXDIFF:   27 bytes:  7603200/  7603200